'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = getDocFile;
var jsdoc = require('jsdoc-api');
var getParseBabel = require('./getParseBabel');

function getDocFile(jscodeReqest, file) {
	try {
		var babelifycode = getParseBabel(jscodeReqest, '2017', true);
		var docReturn = jsdoc.explainSync({
			source: babelifycode.code
		}).filter(function (obj) {
			return obj.undocumented !== true;
		}).map(function (obj) {
			if (obj.meta) {
				obj.meta.filename = file;
				obj.meta.path = file;
			} else {
				obj.files[0] = file;
			}
			return obj;
		});
		return docReturn;
	} catch (err) {
		var errorMessage = err.toString();
		console.log('\n' + errorMessage + '\n');
		throw new Error(err);
	}
}