'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

exports.default = processProps;

var _getProp = require('./getProp');

var _getProp2 = _interopRequireDefault(_getProp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function processProps(docFile, component) {
	var props = component.props;
	var mixins = component.mixins;
	if (mixins) {
		mixins.forEach(function (mixin) {
			var pMixin = mixin.props;
			if (pMixin) {
				props = (0, _assign2.default)({}, pMixin, props);
			}
		});
	}
	if (props) {
		var listDocProps = {};
		if (Array.isArray(props)) {
			props.forEach(function (propName) {
				listDocProps[propName] = (0, _getProp2.default)();
			});
		} else {
			docFile.reverse();
			(0, _keys2.default)(props).forEach(function (key) {
				var propName = key;
				var docPart = docFile.reverse().filter(function (comment) {
					return comment.longname.indexOf('props.' + propName) > -1;
				})[0];
				var prop = props[propName];
				var docProp = (0, _getProp2.default)(prop, docPart);
				listDocProps[propName] = docProp;
			});
		}
		return listDocProps;
	}
	return;
}